<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Edit Requirements</title>

<style>
html, body {
    margin: 0;
    padding: 0;
    font-size: 75%;
}
</style>
<link rel="stylesheet" type="text/css" media="screen" href="../css/jquery_ui_1.8.18.custom.css" />
<link rel="stylesheet" type="text/css" media="screen" href="../css/ui.jqgrid.css" />
<link rel="stylesheet" type="text/css" media="screen" href="../css/ui.datepicker.css" />
<script src="../../ClientGlobalContext.js.aspx" type="text/javascript"> </script>
<script src="../js/jquery_min.js"></script>
<script src="../js/jquery_ui_min.js"></script>
<!--<script src="js/jquery-1.7.1.min.js" type="text/javascript"></script>-->
<script src="../js/grid.locale_en.js" type="text/javascript"></script>
<script src="../js/jquery.jqGrid.min.js" type="text/javascript"></script>
<script src="../js/json2.js" type="text/javascript"></script>
<script src="../js/CRMUpdate.js" type="text/javascript"></script>
 
<script type="text/javascript">
var context = GetGlobalContext();
var serverUrl = context.getServerUrl();
var ODataPath = serverUrl + "/XRMServices/2011/OrganizationData.svc";
var OppID = getQuerystring('id');
var ODataQuery = ODataPath + "/A422_OpportunityRequirementSet?$select=A422_OpportunityRequirementId,a422_opportunityid,a422_rel_activitycategoryid,a422_rel_activityvalueid,A422_Waived,A422_Completion,A422_OrganizationName&$filter=a422_opportunityid/Id eq guid'" + OppID + "'";
var lastsel;
jQuery.support.cors = true;
jQuery(document).ready(function(){ 
  $("#list").jqGrid({
    url: ODataQuery,
    datatype: "json",
	contentType: "application/json; charset=utf-8", 
    //mtype: 'GET',
    colNames:['ItemID','Activity Category','Activity Value','Organization Name','Waived','Completed','Action'],
    colModel :[ 
	  {name:'A422_OpportunityRequirementId', label:'ID', hidden:true},
	  {name:'a422_rel_activitycategoryid.Name', label:'a422_rel_activitycategoryid', width:70}, 
      {name:'a422_rel_activityvalueid.Name', label:'a422_rel_activityvalueid', width:70},
	  {name:'A422_OrganizationName', label:'A422_OrganizationName', width:80, editable:false},
      {name:'A422_Waived', label:'A422_Waived', editable:true, edittype:'checkbox', editoptions: { value:"true:false" }, width:20, align:'right', formatter: 'checkbox', align:'center'},
      {name:'A422_Completion', label:'A422_Completion', editable:true, width:30, sorttype:"date", formatter:'date'},
	  {name:'act',index:'act', width:25,sortable:false, align:'center'},
    ],

    pager: '#pager',
	pgbuttons: false,
	pginput: false,
	autowidth: true,
	//forceFit: true,
	shrinkToFit: true,
	height: 164,
    rowNum: 300,
	//scroll: true,
    //rowList:[10,20,30],
    //sortname: 'a422_rel_activitycategoryid',
    //sortorder: 'desc',
    viewrecords: true,
    //gridview: true,
	//cellEdit : true,
	//cellsubmit: "clientArray",
	caption: "<img src='../icons/AddNew.gif' style='cursor: pointer' alt='Add New Requirement' onclick=\"NewReq('" + OppID + "');\" /> Add New Requirement <img src='../icons/RefreshIcon.png' style='position:absolute;right:0px;' onclick=\"jQuery('#list').trigger('reloadGrid');\" />",
	onSelectRow: function(id){
		if(id && id!==lastsel){
			saved = 0;
			jQuery('#list').jqGrid('restoreRow',lastsel,
			{
				afterrestorefunc : function() {clearChanges(lastsel);}
			});
			jQuery('#list').jqGrid('editRow',id,
			{
			keys : false,
			oneditfunc: function() {pickdates(id);},
			url : 'clientArray',
			aftersavefunc : function() {updateCRM(id, "A422_OpportunityRequirementSet");}
			});
			lastsel=id;
		}
	},
	gridComplete: function(){
		var ids = jQuery('#list').jqGrid('getDataIDs');
		for(var i=0;i < ids.length;i++){
			var cl = ids[i];
			//be = "<input style='height:22px;width:20px;' type='button' value='E' onclick=\"jQuery('#list').editRow('"+cl+"');\"  />"; 
			//se = "<input style='height:22px;width:20px;' type='button' value='S' onclick=\"jQuery('#list').jqGrid('saveRow','"+cl+"',{ url : 'clientArray', aftersavefunc : function() {updateCRM('"+cl+"', 'A422_OpportunityRequirementSet');}});\" />"; 
			//ce = "<input style='height:22px;width:20px;' type='button' value='C' onclick=\"jQuery('#list').restoreRow('"+cl+"');\" />"; 
			be = "<img src='../icons/EditIcon.png' alt='Edit Row' />";
			//se = "<img src='../icons/SaveIcon.png' style='cursor: pointer' alt='Save Changes' onclick=\"jQuery('#list').jqGrid('saveRow','"+cl+"',{ url : 'clientArray', aftersavefunc : function() {updateCRM('"+cl+"', 'A422_OpportunityRequirementSet');}});\" />";
			//ce = "<img src='../icons/CancelIcon.png' style='padding-left: 10px; cursor: pointer' alt='Clear Changes' onclick=\"jQuery('#list').restoreRow('"+cl+"',clearChanges('"+cl+"');\" />"; 
			jQuery('#list').jqGrid('setRowData',ids[i],{act:be});
		}	
	},
	
	ondblClickRow: function(id) { EditForm(id); },
	
	jsonReader : {
      root: "d.results",
      page: function (obj) { return 1; },
      total: function (obj) { return 1; },
	  records: function (obj) { return obj.length; },
      repeatitems: false,
	  cell: "",
      id:"A422_OpportunityRequirementId"
	  }
  }); 
}); 

$(window).bind('resize', function () {
     $("#list").setGridWidth($(window).width() - 5);
        }).trigger('resize');

function pickdates(id){
	//display date picker in completion date column
	$("#"+id+"_A422_Completion","#list").datepicker({dateFormat:"mm/dd/yy"});
	//display save and clear icons in action column
	se = "<img src='../icons/SaveIcon.png' style='cursor: pointer' alt='Save Changes' onclick=\"jQuery('#list').jqGrid('saveRow','"+id+"',{ url : 'clientArray', aftersavefunc : function() {updateCRM('"+id+"', 'A422_OpportunityRequirementSet');}});\" />";
	//+ce = "<img src='../icons/CancelIcon.png' style='padding-left: 10px; cursor: pointer' alt='Clear Changes' onclick=\"jQuery('#list').restoreRow('"+id+"');\" />"; 
	jQuery('#list').jqGrid('setRowData',id,{act:se});
	document.getElementById("cbDirty").checked=true;
}

function clearChanges(id){
		var cid = 'c' + id;
		if (!document.getElementById(cid))
		{
			be = "<img src='../icons/EditIcon.png' alt='Edit Row' />";
			jQuery('#list').jqGrid('setRowData',id,{act:be});
		}
}

//Opens new requirement form
function NewReq(id){
var etc = getETC("a422_opportunityrequirement");
window.open(serverUrl + 'main.aspx?etc=' + etc + '&extraqs=%3f_CreateFromId%3d' +id + '%26_CreateFromType%3d3%26etc%3d' + etc + '%26pagemode%3diframe%26preloadcache%3d1347033937997&pagetype=entityrecord', '', 'width=850,height=650');
}

//Opens edit requirement form
function EditForm(id){
var etc = getETC("a422_opportunityrequirement");
window.open(serverUrl + 'main.aspx?etc=' + etc + '&extraqs=%3f_gridType%3d' + etc + '%26etc%3d' + etc + '%26id%3d' + id +'%26pagemode%3diframe%26preloadcache%3d1347379993560%26rskey%3d441966254&pagetype=entityrecord', '', 'width=850,height=650');
}

//Parse querystring to get record ID
function getQuerystring(key, default_)
 {
   if (default_==null) default_=""; 
  key = key.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
   var regex = new RegExp("[\\?&]"+key+"=([^&#]*)");
   var qs = regex.exec(window.location.href);
   if(qs == null)
     return default_;
   else
     return qs[1];
 }
 
 function getETC(entityName) {
 
try {
	var lookupService = new parent.RemoteCommand("LookupService", "RetrieveTypeCode");
	lookupService.SetParameter("entityName", entityName);
	var result = lookupService.Execute();
	if (result.Success && typeof result.ReturnValue == "number") {
		return result.ReturnValue;
	} else {
		return null;
	}
} catch (e) {
	alert("Error while getting ETC by Name – " + e.description);
	}
}

 
</script>
 
</head>
<body>
<table id="list"><tr><td/></tr></table> 
<div id="pager"></div> 
<div id="datepicker"></div>
<input type="checkbox" id="cbDirty" value="test" style="display: none;"/>
</body>
</html>